



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Kafka设计原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Kafka设计原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 01:20:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、入门</strong></p>
<p><strong>1.简介</strong></p>
<p><a href="http://kafka.apache.org/" rel="external nofollow noreferrer">Apache Kafka</a>是一个分布式消息发布订阅系统。它最初由LinkedIn公司基于独特的设计实现为一个分布式的提交日志系统( a distributed commit log)，之后成为Apache项目的一部分。Kafka系统快速、可扩展并且可持久化。分区，可复制和可容错都是其不错的特性。它提供了类似于JMS的特性，但是在设计实现上完全不同，此外它并不是JMS规范的实现。</p>
<p>Apache Kafka与传统消息系统相比，有以下不同：</p>
<ul><li>它被设计为一个分布式系统，易于向外扩展；
<li>它同时为发布和订阅提供高吞吐量；
<li>它支持多订阅者，当失败时能自动平衡消费者；
<li>将消息持久化到磁盘，因此可用于批量消费，例如ETL，以及实时应用程序。</li></ul>
<p><strong>2.基本术语</strong></p>
<div>
<pre class="prettyprint linenums">producer：消息生产者，发布消息到 kafka 集群的终端或服务。<br />
broker：kafka 集群中每一个服务器都是一个代理(broker)。<br />
topic：每条发布到 kafka 集群的消息属于的类别，即 kafka 是面向 topic 的。<br />
partition：partition 是物理上的概念，每个 topic 包含一个或多个 partition。kafka 分配的单位是 partition。<br />
consumer：从 kafka 集群中消费消息的终端或服务。<br />
consumer group： high-level consumer API 中每个consumer都属于一个consumer group，每条消息只能被consumer group 的一个Consumer消费，但可以被多个consumer group消费。<br />
replica：partition 的副本，保障 partition 的高可用。<br />
leader：replica 中的一个角色， producer 和 consumer 只跟 leader 交互。<br />
follower：replica 中的一个角色，从 leader 中复制数据。<br />
controller：kafka 集群中的其中一个服务器，用来进行 leader election 以及各种 failover。<br />
zookeeper：kafka 通过 zookeeper 来存储集群的 meta 信息。</pre>
</div>
<p><strong>3.kafka拓扑结构</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1157155/201706/1157155-20170606144252840-651904344.png"></p>
<p><strong>4.Zookeeper节点</strong></p>
<p>kafka 在 zookeeper 中的存储结构如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1157155/201706/1157155-20170606144254590-444406431.png"></p>
<p><strong>二、设计原理详解</strong></p>
<p><strong>1.概念深入理解</strong></p>
<p><strong>1.1.Topics/logs</strong></p>
<p>一个Topic可以认为是一类消息，每个topic将被分成多个partition(区),每个partition在存储层面是append log文件。任何发布到此partition的消息都会被直接追加到log文件的尾部，每条消息在文件中的位置称为offset（偏移量），offset为一个long型数字，它是唯一标记一条消息。kafka并没有提供其他额外的索引机制来存储offset，因为在kafka中几乎不允许对消息进行“随机读写”。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1157155/201706/1157155-20170606143811918-1985342959.png"></p>
<p>kafka和JMS（Java Message Service）实现(activeMQ)不同的是:即使消息被消费,消息仍然不会被立即删除.日志文件将会根据broker中的配置要求,保留一定的时间之后删除;比如log文件保留2天,那么两天后,文件会被清除,无论其中的消息是否被消费.kafka通过这种简单的手段,来释放磁盘空间,以及减少消息消费之后对文件内容改动的磁盘IO开支.</p>
<p>对于consumer而言,它需要保存消费消息的offset,对于offset的保存和使用,有consumer来控制;当consumer正常消费消息时,offset将会"线性"的向前驱动,即消息将依次顺序被消费.事实上consumer可以使用任意顺序消费消息,它只需要将offset重置为任意值.(offset将会保存在zookeeper中)</p>
<p>kafka集群几乎不需要维护任何consumer和producer状态信息,这些信息有zookeeper保存;因此producer和consumer的客户端实现非常轻量级,它们可以随意离开,而不会对集群造成额外的影响.</p>
<p>partitions的设计目的有多个.最根本原因是kafka基于文件存储.通过分区,可以将日志内容分散到多个server上,来避免文件尺寸达到单机磁盘的上限,每个partiton都会被当前server(kafka实例)保存;可以将一个topic切分多任意多个partitions,来消息保存/消费的效率.此外越多的partitions意味着可以容纳更多的consumer,有效提升并发消费的能力.</p>
<p><strong>1.2.Distribution</strong></p>
<p>一个Topic的多个partitions,被分布在kafka集群中的多个server上;每个server(kafka实例)负责partitions中消息的读写操作;此外kafka还可以配置partitions需要备份的个数(replicas),每个partition将会被备份到多台机器上,以提高可用性.</p>
<p>基于replicated方案,那么就意味着需要对多个备份进行调度;每个partition都有一个<a href="http://cpro.baidu.com/cpro/ui/uijs.php?rs=1&amp;u=http%3A%2F%2Fwww%2Eaboutyun%2Ecom%2Fthread%2D9341%2D1%2D1%2Ehtml&amp;p=baidu&amp;c=news&amp;n=10&amp;t=tpclicked3_hc&amp;q=92051019_cpr&amp;k=server&amp;k0=java&amp;kdi0=8&amp;k1=%B1%E0%B3%CC&amp;kdi1=8&amp;k2=%BF%CD%BB%A7%B6%CB&amp;kdi2=8&amp;k3=%C9%E8%BC%C6&amp;kdi3=8&amp;k4=server&amp;kdi4=1&amp;sid=4ebca4a25f27e407&amp;ch=0&amp;tu=u1692056&amp;jk=fb2f0911808fa875&amp;cf=29&amp;fv=14&amp;stid=9&amp;urlid=0&amp;luki=5&amp;seller_id=1&amp;di=128" rel="external nofollow noreferrer">server</a>为"leader";leader负责所有的读写操作,如果leader失效,那么将会有其他follower来接管(成为新的leader);follower只是单调的和leader跟进,同步消息即可..由此可见作为leader的server承载了全部的请求压力,因此从集群的整体考虑,有多少个partitions就意味着有多少个"leader",kafka会将"leader"均衡的分散在每个实例上,来确保整体的性能稳定.</p>
<p><strong>1.3.Producers</strong></p>
<p>Producer将消息发布到指定的Topic中,同时Producer也能决定将此消息归属于哪个partition;比如基于"round-robin"方式或者通过其他的一些算法等.开发者负责如何选择分区的算法。</p>
<p><strong>1.4.Consumers</strong></p>
<p>本质上kafka只支持Topic.每个consumer属于一个consumer group;反过来说,每个group中可以有多个consumer.发送到Topic的消息,只会被订阅此Topic的每个group中的一个consumer消费.</p>
<p>如果所有的consumer都具有相同的group,这种情况和queue模式很像;消息将会在consumers之间负载均衡.</p>
<p>如果所有的consumer都具有不同的group,那这就是"发布-订阅";消息将会广播给所有的消费者.</p>
<p>在kafka中,一个partition中的消息只会被group中的一个consumer消费;每个group中consumer消息消费互相独立;我们可以认为一个group是一个"订阅"者,一个Topic中的每个partions,只会被一个"订阅者"中的一个consumer消费,不过一个consumer可以消费多个partitions中的消息.kafka只能保证一个partition中的消息被某个consumer消费时,消息是顺序的.事实上,从Topic角度来说,消息仍不是有序的（不能保证跨分区的消息先后处理顺序）.</p>
<p>kafka的设计原理决定,对于一个topic,同一个group中不能有多于partitions个数的consumer同时消费,否则将意味着某些consumer将无法得到消息.</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1157155/201706/1157155-20170606144256231-2109012933.png"></p>
<p><strong>1.5.Guarantees</strong></p>
<p>1) 发送到partitions中的消息将会按照它接收的顺序追加到日志中</p>
<p>2) 对于消费者而言,它们消费消息的顺序和日志中消息顺序一致.</p>
<p>3) 如果Topic的"replicationfactor"为N,那么允许N-1个kafka实例失效.</p>
<p><strong>2.设计原理</strong></p>
<p>kafka的设计初衷是希望作为一个统一的信息收集平台,能够实时的收集反馈信息,并需要能够支撑较大的数据量,且具备良好的容错能力.</p>
<p><strong>2.1、持久性</strong></p>
<p>kafka使用文件存储消息,这就直接决定kafka在性能上严重依赖文件系统的本身特性.且无论任何OS下,对文件系统本身的优化几乎没有可能.文件缓存/直接内存映射等是常用的手段.因为kafka是对日志文件进行append操作,因此磁盘检索的开支是较小的;同时为了减少磁盘写入的次数,broker会将消息暂时buffer起来,当消息的个数(或尺寸)达到一定阀值时,再flush到磁盘,这样减少了磁盘IO调用的次数.</p>
<p><strong>2.2、性能</strong></p>
<p>需要考虑的影响性能点很多,除磁盘IO之外,我们还需要考虑网络IO,这直接关系到kafka的吞吐量问题.kafka并没有提供太多高超的技巧;对于producer端,可以将消息buffer起来,当消息的条数达到一定阀值时,批量发送给broker;对于consumer端也是一样,批量fetch多条消息.不过消息量的大小可以通过配置文件来指定.对于kafka broker端,似乎有个sendfile系统调用可以潜在的提升网络IO的性能:将文件的数据映射到系统内存中,socket直接读取相应的内存区域即可,而无需进程再次copy和交换. 其实对于producer/consumer/broker三者而言,CPU的开支应该都不大,因此启用消息压缩机制是一个良好的策略;压缩需要消耗少量的CPU资源,不过对于kafka而言,网络IO更应该需要考虑.可以将任何在网络上传输的消息都经过压缩.kafka支持gzip/snappy等多种压缩方式.</p>
<p><strong>2.3、生产者</strong></p>
<p>负载均衡: producer将会和Topic下所有partition leader保持socket连接;消息由producer直接通过socket发送到broker,中间不会经过任何"路由层".事实上,消息被路由到哪个partition上,有producer客户端决定.比如可以采用"random""key-hash""轮询"等,如果一个topic中有多个partitions,那么在producer端实现"消息均衡分发"是必要的.</p>
<p>其中partition leader的位置(host:port)注册在zookeeper中,producer作为zookeeper client,已经注册了watch用来监听partition leader的变更事件.</p>
<p>异步发送：将多条消息暂且在客户端buffer起来，并将他们批量的发送到broker，小数据IO太多，会拖慢整体的网络延迟，批量延迟发送事实上提升了网络效率。不过这也有一定的隐患，比如说当producer失效时，那些尚未发送的消息将会丢失。</p>
<p><strong>2.4、消费者</strong></p>
<p>consumer端向broker发送"fetch"请求,并告知其获取消息的offset;此后consumer将会获得一定条数的消息;consumer端也可以重置offset来重新消费消息.</p>
<p>在JMS实现中,Topic模型基于push方式,即broker将消息推送给consumer端.不过在kafka中,采用了pull方式,即consumer在和broker建立连接之后,主动去pull(或者说fetch)消息;这种模式有些优点,首先consumer端可以根据自己的消费能力适时的去fetch消息并处理,且可以控制消息消费的进度(offset);此外,消费者可以良好的控制消息消费的数量,batch fetch.</p>
<p>其他JMS实现,消息消费的位置是有prodiver保留,以便避免重复发送消息或者将没有消费成功的消息重发等,同时还要控制消息的状态.这就要求JMS broker需要太多额外的工作.在kafka中,partition中的消息只有一个consumer在消费,且不存在消息状态的控制,也没有复杂的消息确认机制,可见kafka broker端是相当轻量级的.当消息被consumer接收之后,consumer可以在本地保存最后消息的offset,并间歇性的向zookeeper注册offset.由此可见,consumer客户端也很轻量级.</p>
<p><strong>2.5、消息传送机制</strong></p>
<p>对于JMS实现,消息传输担保非常直接:有且只有一次(exactly once).在kafka中稍有不同:</p>
<p>1) at most once: 最多一次,这个和JMS中"非持久化"消息类似.发送一次,无论成败,将不会重发.</p>
<p>2) at least once: 消息至少发送一次,可能会重发.</p>
<p>3) exactly once: 消息有且只会发送一次.</p>
<p>at most once: 消费者fetch消息,然后保存offset,然后处理消息;当client保存offset之后,但是在消息处理过程中出现了异常,导致部分消息未能继续处理.那么此后"未处理"的消息将不能被fetch到,这就是"at most once".</p>
<p>at least once: 消费者fetch消息,然后处理消息,然后保存offset.如果消息处理成功之后,但是在保存offset阶段zookeeper异常导致保存操作未能执行成功,这就导致接下来再次fetch时可能获得上次已经处理过的消息,这就是"at least once"，原因offset没有及时的提交给zookeeper，zookeeper恢复正常还是之前offset状态.</p>
<p>exactly once: kafka中并没有严格的去实现(基于2阶段提交,事务),我们认为这种策略在kafka中是没有必要的.</p>
<p>通常情况下"at-least-once"是我们首选.(相比at most once而言,重复接收数据总比丢失数据要好).</p>
<p><strong>2.6、复制备份</strong></p>
<p>kafka将每个partition数据复制到多个server上,任何一个partition有一个leader和多个follower(可以没有);备份的个数可以通过broker配置文件来设定.leader处理所有的read-write请求,follower需要和leader保持同步.Follower和consumer一样,消费消息并保存在本地日志中;leader负责跟踪所有的follower状态,如果follower"落后"太多或者失效,leader将会把它从replicas同步列表中删除.当所有的follower都将一条消息保存成功,此消息才被认为是"committed",那么此时consumer才能消费它.即使只有一个replicas实例存活,仍然可以保证消息的正常发送和接收,只要zookeeper集群存活即可.(不同于其他分布式存储,比如hbase需要"多数派"存活才行)</p>
<p>当leader失效时,需在followers中选取出新的leader,可能此时follower落后于leader,因此需要选择一个"up-to-date"的follower.选择follower时需要兼顾一个问题,就是新leaderserver上所已经承载的partition leader的个数,如果一个server上有过多的partition leader,意味着此server将承受着更多的IO压力.在选举新leader,需要考虑到"负载均衡".</p>
<p><strong>2.7、日志</strong></p>
<p>如果一个topic的名称为"my_topic",它有2个partitions,那么日志将会保存在my_topic_0和my_topic_1两个目录中;日志文件中保存了一序列"log entries"(日志条目),每个log entry格式为"4个字节的数字N表示消息的长度" + "N个字节的消息内容";每个日志都有一个offset来唯一的标记一条消息,offset的值为8个字节的数字,表示此消息在此partition中所处的起始位置..每个partition在物理存储层面,有多个log file组成(称为segment).segmentfile的命名为"最小offset".kafka.例如"00000000000.kafka";其中"最小offset"表示此segment中起始消息的offset.</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1157155/201706/1157155-20170606143816590-241665677.png"></p>
<p>其中每个partiton中所持有的segments列表信息会存储在zookeeper中.</p>
<p>当segment文件尺寸达到一定阀值时(可以通过配置文件设定,默认1G),将会创建一个新的文件;当buffer中消息的条数达到阀值时将会触发日志信息flush到日志文件中,同时如果"距离最近一次flush的时间差"达到阀值时,也会触发flush到日志文件.如果broker失效,极有可能会丢失那些尚未flush到文件的消息.因为server意外失效,仍然会导致log文件格式的破坏(文件尾部),那么就要求当server启动时需要检测最后一个segment的文件结构是否合法并进行必要的修复.</p>
<p>获取消息时,需要指定offset和最大chunk尺寸,offset用来表示消息的起始位置,chunk size用来表示最大获取消息的总长度(间接的表示消息的条数).根据offset,可以找到此消息所在segment文件,然后根据segment的最小offset取差值,得到它在file中的相对位置,直接读取输出即可.</p>
<p>日志文件的删除策略非常简单:启动一个后台线程定期扫描log file列表,把保存时间超过阀值的文件直接删除(根据文件的创建时间).为了避免删除文件时仍然有read操作(consumer消费),采取copy-on-write方式.</p>
<p><strong>2.8、分配</strong></p>
<p>kafka使用zookeeper来存储一些meta信息,并使用了zookeeper watch机制来发现meta信息的变更并作出相应的动作(比如consumer失效,触发负载均衡等)</p>
<p>1) Broker node registry: 当一个kafkabroker启动后,首先会向zookeeper注册自己的节点信息(临时znode),同时当broker和zookeeper断开连接时,此znode也会被删除.</p>
<p>格式: /broker/ids/[0...N]&nbsp;&nbsp; --&gt;host:port;其中[0..N]表示broker id,每个broker的配置文件中都需要指定一个数字类型的id(全局不可重复),znode的值为此broker的host:port信息.</p>
<p>2) Broker Topic Registry: 当一个broker启动时,会向zookeeper注册自己持有的topic和partitions信息,仍然是一个临时znode.</p>
<p>格式: /broker/topics/[topic]/[0...N]&nbsp; 其中[0..N]表示partition索引号.</p>
<p>3) Consumer and Consumer group: 每个consumer客户端被创建时,会向zookeeper注册自己的信息;此作用主要是为了"负载均衡".</p>
<p>一个group中的多个consumer可以交错的消费一个topic的所有partitions;简而言之,保证此topic的所有partitions都能被此group所消费,且消费时为了性能考虑,让partition相对均衡的分散到每个consumer上.</p>
<p>4) Consumer id Registry: 每个consumer都有一个唯一的ID(host:uuid,可以通过配置文件指定,也可以由系统生成),此id用来标记消费者信息.</p>
<p>格式:/consumers/[group_id]/ids/[consumer_id]</p>
<p>仍然是一个临时的znode,此节点的值为{"topic_name":#streams...},即表示此consumer目前所消费的topic + partitions列表.</p>
<p>5) Consumer offset Tracking: 用来跟踪每个consumer目前所消费的partition中最大的offset.</p>
<p>格式:/consumers/[group_id]/offsets/[topic]/[broker_id-partition_id]--&gt;offset_value</p>
<p>此znode为持久节点,可以看出offset跟group_id有关,以表明当group中一个消费者失效,其他consumer可以继续消费.</p>
<p>6) Partition Owner registry: 用来标记partition被哪个consumer消费.临时znode</p>
<p>格式:/consumers/[group_id]/owners/[topic]/[broker_id-partition_id]--&gt;consumer_node_id</p>
<p>当consumer启动时,所触发的操作:</p>
<p>A) 首先进行"Consumer id Registry";</p>
<p>B) 然后在"Consumer id Registry"节点下注册一个watch用来监听当前group中其他consumer的"leave"和"join";只要此znode path下节点列表变更,都会触发此group下consumer的负载均衡.(比如一个consumer失效,那么其他consumer接管partitions).</p>
<p>C) 在"Broker id registry"节点下,注册一个watch用来监听broker的存活情况;如果broker列表变更,将会触发所有的groups下的consumer重新balance.</p>
<p>1) Producer端使用zookeeper用来"发现"broker列表,以及和Topic下每个partition leader建立socket连接并发送消息.</p>
<p>2) Broker端使用zookeeper用来注册broker信息,已经监测partitionleader存活性.</p>
<p>3) Consumer端使用zookeeper用来注册consumer信息,其中包括consumer消费的partition列表等,同时也用来发现broker列表,并和partition leader建立socket连接,并获取消息.</p>
<p><strong>三、使用场景</strong></p>
<p><strong>1、Messaging</strong></p>
<p>对于一些常规的消息系统,kafka是个不错的选择;partitons/replication和容错,可以使kafka具有良好的扩展性和性能优势.不过到目前为止,我们应该很清楚认识到,kafka并没有提供JMS中的"事务性""消息传输担保(消息确认机制)""消息分组"等企业级特性;kafka只能使用作为"常规"的消息系统,在一定程度上,尚未确保消息的发送与接收绝对可靠(比如,消息重发,消息发送丢失等)</p>
<p><strong>2、Websit activity tracking</strong></p>
<p>kafka可以作为"网站活性跟踪"的最佳工具;可以将网页/用户操作等信息发送到kafka中.并实时监控,或者离线统计分析等</p>
<p><strong>3、Log Aggregation</strong></p>
<p>kafka的特性决定它非常适合作为"日志收集中心";application可以将操作日志"批量""异步"的发送到kafka集群中,而不是保存在本地或者DB中;kafka可以批量提交消息/压缩消息等,这对producer端而言,几乎感觉不到性能的开支.此时consumer端可以使hadoop等其他系统化的存储和分析系统.</p>
<p><strong>四、源码分析</strong></p>
<p><strong>4.1.producer发布消息</strong></p>
<h5><strong>4.1.1 写入方式</strong></h5>
<p>producer 采用 push 模式将消息发布到 broker，每条消息都被 append 到 patition 中，属于顺序写磁盘（顺序写磁盘效率比随机写内存要高，保障 kafka 吞吐率）。</p>
<h5><strong>4.1.2 消息路由</strong></h5>
<p>producer 发送消息到 broker 时，会根据分区算法选择将其存储到哪一个 partition。其路由机制为：</p>
<div>1). 指定了 patition，则直接使用；
<pre class="prettyprint linenums">2). 未指定 patition 但指定 key，通过对 key 的 value 进行hash 选出一个 patition</pre>
<pre class="prettyprint linenums">3). patition 和 key 都未指定，使用轮询选出一个 patition。</pre>
</div>
<p><strong>4.1.3 写入流程</strong></p>
<p>producer 写入消息序列图如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897247/201610/897247-20161012131406546-202763949.png"></p>
<p>流程说明：</p>
<div>
<pre class="prettyprint linenums">1). producer 先从 zookeeper 的 "/brokers/.../state" 节点找到该 partition 的 leader<br />
2). producer 将消息发送给该 leader<br />
3). leader 将消息写入本地 log<br />
4). followers 从 leader pull 消息，写入本地 log 后 leader 发送 ACK<br />
5). leader 收到所有 ISR 中的 replica 的 ACK 后，增加 HW（high watermark，最后 commit 的 offset） 并向 producer 发送 ACK</pre>
</div>
<h5><strong>4.1.4 producer delivery guarantee</strong></h5>
<p>一般情况下存在三种情况：</p>
<div>
<pre class="prettyprint linenums">1. At most once 消息可能会丢，但绝不会重复传输<br />
2. At least one 消息绝不会丢，但可能会重复传输<br />
3. Exactly once 每条消息肯定会被传输一次且仅传输一次</pre>
</div>
<p>当 producer 向 broker 发送消息时，一旦这条消息被 commit，由于 replication 的存在，它就不会丢。但是如果 producer 发送数据给 broker 后，遇到网络问题而造成通信中断，那 Producer 就无法判断该条消息是否已经 commit。虽然 Kafka 无法确定网络故障期间发生了什么，但是 producer 可以生成一种类似于主键的东西，发生故障时幂等性的重试多次，这样就做到了 Exactly once，但目前还并未实现。所以目前默认情况下一条消息从 producer 到 broker 是确保了 At least once，可通过设置 producer 异步发送实现At most once。</p>
<h4><strong>4.2.broker 保存消息</strong></h4>
<h5><strong>4.2.1 存储方式</strong></h5>
<p>物理上把 topic 分成一个或多个 patition（对应 server.properties 中的 num.partitions=3 配置），每个 patition 物理上对应一个文件夹（该文件夹存储该 patition 的所有消息和索引文件），如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897247/201610/897247-20161012105133296-413851676.png"></p>
<h5><strong>4.2.2 存储策略</strong></h5>
<p>无论消息是否被消费，kafka 都会保留所有消息。有两种策略可以删除旧数据：</p>
<div>
<pre class="prettyprint linenums">1). 基于时间：log.retention.hours=168<br />
2). 基于大小：log.retention.bytes=1073741824</pre>
</div>
<p>需要注意的是，因为Kafka读取特定消息的时间复杂度为O(1)，即与文件大小无关，所以这里删除过期文件与提高 Kafka 性能无关。</p>
<h5><strong>4.2.3 topic 创建与删除</strong></h5>
<h6><strong>4.2.3.1 创建 topic</strong></h6>
<p>创建 topic 的序列图如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897247/201610/897247-20161012161552718-1963426687.png"></p>
<p>流程说明：</p>
<div>
<pre class="prettyprint linenums">1). controller 在 ZooKeeper 的 /brokers/topics 节点上注册 watcher，当 topic 被创建，则 controller 会通过 watch 得到该 topic 的 partition/replica 分配。<br />
2). controller从 /brokers/ids 读取当前所有可用的 broker 列表，对于 set_p 中的每一个 partition：<br />
     2.1) 从分配给该 partition 的所有 replica（称为AR）中任选一个可用的 broker 作为新的 leader，并将AR设置为新的 ISR<br />
    2.2) 将新的 leader 和 ISR 写入 /brokers/topics/[topic]/partitions/[partition]/state<br />
3). controller 通过 RPC 向相关的 broker 发送 LeaderAndISRRequest。</pre>
</div>
<h6><strong>4.2.3.2 删除 topic</strong></h6>
<p>删除 topic 的序列图如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897247/201610/897247-20161012162436140-850153613.png"></p>
<p>流程说明：</p>
<div>
<pre class="prettyprint linenums">1). controller 在 zooKeeper 的 /brokers/topics 节点上注册 watcher，当 topic 被删除，则 controller 会通过 watch 得到该 topic 的 partition/replica 分配。<br />
2). 若 delete.topic.enable=false，结束；否则 controller 注册在 /admin/delete_topics 上的 watch 被 fire，controller 通过回调向对应的 broker 发送 StopReplicaRequest。</pre>
</div>
<h4><strong>4.3.kafka HA</strong></h4>
<h5><strong>4.3.1 replication</strong></h5>
<p>同一个 partition 可能会有多个 replica（对应 server.properties 配置中的 default.replication.factor=N）。没有 replica 的情况下，一旦 broker 宕机，其上所有 patition 的数据都不可被消费，同时 producer 也不能再将数据存于其上的 patition。引入replication 之后，同一个 partition 可能会有多个 replica，而这时需要在这些 replica 之间选出一个 leader，producer 和 consumer 只与这个 leader 交互，其它 replica 作为 follower 从 leader 中复制数据。</p>
<p>Kafka 分配 Replica 的算法如下：</p>
<div>
<pre class="prettyprint linenums">1). 将所有 broker（假设共 n 个 broker）和待分配的 partition 排序<br />
2). 将第 i 个 partition 分配到第（i mod n）个 broker 上<br />
3). 将第 i 个 partition 的第 j 个 replica 分配到第（(i + j) mode n）个 broker上</pre>
</div>
<h5><strong>4.3.2 leader failover</strong></h5>
<p>当 partition 对应的 leader 宕机时，需要从 follower 中选举出新 leader。在选举新leader时，一个基本的原则是，新的 leader 必须拥有旧 leader commit 过的所有消息。</p>
<p>kafka 在 zookeeper 中（/brokers/.../state）动态维护了一个 ISR（in-sync replicas），由4.1.3节的写入流程可知 ISR 里面的所有 replica 都跟上了 leader，只有 ISR 里面的成员才能选为 leader。对于 f+1 个 replica，一个 partition 可以在容忍 f 个 replica 失效的情况下保证消息不丢失。</p>
<p>当所有 replica 都不工作时，有两种可行的方案：</p>
<div>
<pre class="prettyprint linenums">1). 等待 ISR 中的任一个 replica 活过来，并选它作为 leader。可保障数据不丢失，但时间可能相对较长。<br />
2). 选择第一个活过来的 replica（不一定是 ISR 成员）作为 leader。无法保障数据不丢失，但相对不可用时间较短。</pre>
</div>
<p>kafka 0.8.* 使用第二种方式。</p>
<h5><strong>4.3.3 broker failover</strong></h5>
<p>kafka broker failover 序列图如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897247/201610/897247-20161012143318812-1534130173.png"></p>
<p>流程说明：</p>
<div>
<pre class="prettyprint linenums">1). controller 在 zookeeper 的 /brokers/ids/[brokerId] 节点注册 Watcher，当 broker 宕机时 zookeeper 会 fire watch<br />
2). controller 从 /brokers/ids 节点读取可用broker<br />
3). controller决定set_p，该集合包含宕机 broker 上的所有 partition<br />
4). 对 set_p 中的每一个 partition<br />
    4.1) 从/brokers/topics/[topic]/partitions/[partition]/state 节点读取 ISR<br />
    4.2) 决定新 leader<br />
    4.3) 将新 leader、ISR、controller_epoch 和 leader_epoch 等信息写入 state 节点<br />
5). 通过 RPC 向相关 broker 发送 leaderAndISRRequest 命令</pre>
</div>
<h5><strong>4.3.4 controller failover</strong></h5>
<p>当 controller 宕机时会触发 controller failover。每个 broker 都会在 zookeeper 的 "/controller" 节点注册 watcher，当 controller 宕机时 zookeeper 中的临时节点消失，所有存活的 broker 收到 fire 的通知，每个 broker 都尝试创建新的 controller path，只有一个竞选成功并当选为 controller。</p>
<p>当新的 controller 当选时，会触发 KafkaController.onControllerFailover 方法，在该方法中完成如下操作：</p>
<div>
<pre class="prettyprint linenums">1). 读取并增加 Controller Epoch。<br />
2). 在 reassignedPartitions Patch(/admin/reassign_partitions) 上注册 watcher。<br />
3). 在 preferredReplicaElection Path(/admin/preferred_replica_election) 上注册 watcher。<br />
4). 通过 partitionStateMachine 在 broker Topics Patch(/brokers/topics) 上注册 watcher。<br />
5). 若 delete.topic.enable=true（默认值是 false），则 partitionStateMachine 在 Delete Topic Patch(/admin/delete_topics) 上注册 watcher。<br />
6). 通过 replicaStateMachine在 Broker Ids Patch(/brokers/ids)上注册Watch。<br />
7). 初始化 ControllerContext 对象，设置当前所有 topic，“活”着的 broker 列表，所有 partition 的 leader 及 ISR等。<br />
8). 启动 replicaStateMachine 和 partitionStateMachine。<br />
9). 将 brokerState 状态设置为 RunningAsController。<br />
10). 将每个 partition 的 Leadership 信息发送给所有“活”着的 broker。<br />
11). 若 auto.leader.rebalance.enable=true（默认值是true），则启动 partition-rebalance 线程。<br />
12). 若 delete.topic.enable=true 且Delete Topic Patch(/admin/delete_topics)中有值，则删除相应的Topic。</pre>
</div>
<h4><strong>4.4. consumer 消费消息</strong></h4>
<h5><strong>4.4.1 consumer API</strong></h5>
<p>kafka 提供了两套 consumer API：</p>
<div>
<pre class="prettyprint linenums">1). The high-level Consumer API<br />
2). The SimpleConsumer API</pre>
</div>
<p>其中 high-level consumer API 提供了一个从 kafka 消费数据的高层抽象，而 SimpleConsumer API 则需要开发人员更多地关注细节。</p>
<h6><strong>4.4.1.1 The high-level consumer API</strong></h6>
<p>high-level consumer API 提供了 consumer group 的语义，一个消息只能被 group 内的一个 consumer 所消费，且 consumer 消费消息时不关注 offset，最后一个 offset 由 zookeeper 保存。</p>
<p>使用 high-level consumer API 可以是多线程的应用，应当注意：</p>
<div>
<pre class="prettyprint linenums">1). 如果消费线程大于 patition 数量，则有些线程将收不到消息<br />
2). 如果 patition 数量大于线程数，则有些线程多收到多个 patition 的消息<br />
3). 如果一个线程消费多个patition，则无法保证你收到的消息的顺序，而一个 patition 内的消息是有序的</pre>
</div>
<h6><strong>4.4.1.2The SimpleConsumer API</strong></h6>
<p>如果你想要对 patition 有更多的控制权，那就应该使用 SimpleConsumer API，比如：</p>
<div>
<pre class="prettyprint linenums">1). 多次读取一个消息<br />
2). 只消费一个 patition 中的部分消息<br />
3). 使用事务来保证一个消息仅被消费一次</pre>
</div>
<p>但是使用此 API 时，partition、offset、broker、leader 等对你不再透明，需要自己去管理。你需要做大量的额外工作：</p>
<div>
<pre class="prettyprint linenums">1). 必须在应用程序中跟踪 offset，从而确定下一条应该消费哪条消息<br />
2). 应用程序需要通过程序获知每个 Partition 的 leader 是谁<br />
3). 需要处理 leader 的变更</pre>
</div>
<p>使用 SimpleConsumer API 的一般流程如下：</p>
<div>
<pre class="prettyprint linenums">1). 查找到一个“活着”的 broker，并且找出每个 partition 的 leader<br />
2). 找出每个 partition 的 follower<br />
3). 定义好请求，该请求应该能描述应用程序需要哪些数据<br />
4). fetch 数据<br />
5). 识别 leader 的变化，并对之作出必要的响应</pre>
</div>
<blockquote><p>以下针对 high-level Consumer API 进行说明。</p></blockquote>
<h5><strong>4.4.2 consumer group</strong></h5>
<p>kafka 的分配单位是 patition。每个 consumer 都属于一个 group，一个 partition 只能被同一个 group 内的一个 consumer 所消费（也就保障了一个消息只能被 group 内的一个 consuemr 所消费），但是多个 group 可以同时消费这个 partition。</p>
<p>kafka 的设计目标之一就是同时实现离线处理和实时处理，根据这一特性，可以使用 spark/Storm 这些实时处理系统对消息在线处理，同时使用 Hadoop 批处理系统进行离线处理，还可以将数据备份到另一个数据中心，只需要保证这三者属于不同的 consumer group。如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/897247/201610/897247-20161012104850453-563375248.png"></p>
<h4><strong>4.4.3 消费方式</strong></h4>
<p>consumer 采用 pull 模式从 broker 中读取数据。</p>
<p>push 模式很难适应消费速率不同的消费者，因为消息发送速率是由 broker 决定的。它的目标是尽可能以最快速度传递消息，但是这样很容易造成 consumer 来不及处理消息，典型的表现就是拒绝服务以及网络拥塞。而 pull 模式则可以根据 consumer 的消费能力以适当的速率消费消息。</p>
<p>对于 Kafka 而言，pull 模式更合适，它可简化 broker 的设计，consumer 可自主控制消费消息的速率，同时 consumer 可以自己控制消费方式——即可批量消费也可逐条消费，同时还能选择不同的提交方式从而实现不同的传输语义。</p>
<h5><strong>4.4.4 consumer delivery guarantee</strong></h5>
<p>如果将 consumer 设置为 autocommit，consumer 一旦读到数据立即自动 commit。如果只讨论这一读取消息的过程，那 Kafka 确保了 Exactly once。</p>
<p>但实际使用中应用程序并非在 consumer 读取完数据就结束了，而是要进行进一步处理，而数据处理与 commit 的顺序在很大程度上决定了consumer delivery guarantee：</p>
<div>
<pre class="prettyprint linenums">1).读完消息先 commit 再处理消息。 这种模式下，如果 consumer 在 commit 后还没来得及处理消息就 crash 了，下次重新开始工作后就无法读到刚刚已提交而未处理的消息，这就对应于 At most once<br />
2).读完消息先处理再 commit。 这种模式下，如果在处理完消息之后 commit 之前 consumer crash 了，下次重新开始工作时还会处理刚刚未 commit 的消息，实际上该消息已经被处理过了。这就对应于 At least once。<br />
3).如果一定要做到 Exactly once，就需要协调 offset 和实际操作的输出。 精典的做法是引入两阶段提交。如果能让 offset 和操作输入存在同一个地方，会更简洁和通用。这种方式可能更好，因为许多输出系统可能不支持两阶段提交。比如，consumer 拿到数据后可能把数据放到 HDFS，如果把最新的 offset 和数据本身一起写到 HDFS，那就可以保证数据的输出和 offset 的更新要么都完成，要么都不完成，间接实现 Exactly once。（目前就 high-level API而言，offset 是存于Zookeeper 中的，无法存于HDFS，而SimpleConsuemr API的 offset 是由自己去维护的，可以将之存于 HDFS 中）</pre>
</div>
<p>总之，Kafka 默认保证 At least once，并且允许通过设置 producer 异步提交来实现 At most once。而 Exactly once 要求与外部存储系统协作，幸运的是 kafka 提供的 offset 可以非常直接非常容易得使用这种方式。</p>
<h5><strong><strong>4.4.5 consumer rebalance</strong></strong></h5>
<p>当有 consumer 加入或退出、以及 partition 的改变（如 broker 加入或退出）时会触发 rebalance。consumer rebalance算法如下：</p>
<div>
<pre class="prettyprint linenums">1). 将目标 topic 下的所有 partirtion 排序，存于PT<br />
2). 对某 consumer group 下所有 consumer 排序，存于 CG，第 i 个consumer 记为 Ci<br />
3). N=size(PT)/size(CG)，向上取整<br />
4). 解除 Ci 对原来分配的 partition 的消费权（i从0开始）<br />
5). 将第i*N到（i+1）*N-1个 partition 分配给 Ci</pre>
</div>
<p>在 0.8.*版本，每个 consumer 都只负责调整自己所消费的 partition，为了保证整个consumer group 的一致性，当一个 consumer 触发了 rebalance 时，该 consumer group 内的其它所有其它 consumer 也应该同时触发 rebalance。这会导致以下几个问题：</p>
<div>
<pre class="prettyprint linenums">1).Herd effect 　　任何 broker 或者 consumer 的增减都会触发所有的 consumer 的 rebalance<br />
2).Split Brain 　　每个 consumer 分别单独通过 zookeeper 判断哪些 broker 和 consumer 宕机了，那么不同 consumer 在同一时刻从 zookeeper 看到的 view 就可能不一样，这是由 zookeeper 的特性决定的，这就会造成不正确的 reblance 尝试。<br />
3). 调整结果不可控 　　所有的 consumer 都并不知道其它 consumer 的 rebalance 是否成功，这可能会导致 kafka 工作在一个不正确的状态。</pre>
</div>
<p>基于以上问题，kafka 设计者考虑在0.9.*版本开始使用中心 coordinator 来控制 consumer rebalance，然后又从简便性和验证要求两方面考虑，计划在 consumer 客户端实现分配方案.</p>
<p><strong>五、参考文章</strong></p>
<p>整个blog摘抄自以下文章。</p>
<p><a href="http://www.cnblogs.com/likehua/p/3999538.html" rel="external nofollow noreferrer">http://www.cnblogs.com/likehua/p/3999538.html</a></p>
<p><a href="http://www.cnblogs.com/cyfonly/p/5954614.html" rel="external nofollow noreferrer">http://www.cnblogs.com/cyfonly/p/5954614.html</a></p>
<p><a href="http://kafka.apache.org/documentation/#brokerconfigs" rel="external nofollow noreferrer">http://kafka.apache.org/documentation/#brokerconfigs</a></p>
<p><a href="http://www.infoq.com/cn/articles/kafka-analysis-part-1/" rel="external nofollow noreferrer">http://www.infoq.com/cn/articles/kafka-analysis-part-1/</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyd15gq.html">转载一篇React native的props的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn57z3q.html">mseed2sac的安装和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrvpdq.html">UIWebView内嵌网页 Xcode7&period;0以后的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r2nw9.html">Django之admin界面恢复及添加数据模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yomgz8.html">浅尝key-value数据库（一）&mdash;&mdash;一览NoSQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zz03g9.html">Effective C&plus;&plus;笔记05：实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp55lr9.html">事件日志：无法加载站点&sol;服务的所有 ISAPI 筛选器。因此启动中止。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1pl6oq.html">nodejs&plus;express&plus;mysql 增删改查&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7ow28.html">jQuery如何制作动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllel4xq.html">【做题】SRM704 Div1 Median - ModEquation&mdash;&mdash;数论</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j2dv5q.html">android数据库简单操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g26rmq.html">Swoole 进程管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgd7xq.html">Jmeter OutofMemory Error</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv56jxq.html">ArrayList 原理&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vxpz0q.html">《玩转Spring》第二章 BeanPostProcessor扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/93penkw8.html">JVM调优总结（6）：新一代的垃圾回收算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve67ro9.html">Linux下帮助命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15kr7z9.html">go&lowbar;数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dmoen8.html">UVALive-3399-Sum of Consecutive Prime Numbers（素数筛，暴力）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmw1n49.html">Timer类注意事项</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90r12w49.html">React native 环境搭建遇到问题解决&lpar;android&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gnplmq.html">c&plus;&plus;中运算符重载</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oj7pg8.html">IdentityServer4 中文文档 -10- （快速入门）使用密码保护API</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwxdkj9.html">Jquery闪烁提示特效</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w6d6zq.html">哆啦A梦欺骗了你！浏览器CSS3测试遭质疑</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvzrdl8.html">Java学习笔记之&mdash;&mdash;数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyl42d9.html">SSM&plus;solr  通过商品搜索学习solr的简单使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5w1l4q.html">Java--实现单点登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwxz2x9.html">matlab中常数下的点是什么意思</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r1yv49.html">23种设计模式&plus;J2EE设计模式学习笔记-初识设计模式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
